<?php

require_once("read_conf.php");
require_once("db.php");
require_once("ssh.php");
require_once("validate_param.php");
require_once("slave_actions.php");

$conf = readmyconf();
$con = connectme($conf);

function build_my_ring($con, $conf, $machine_id, $install_cmd){
    $q = "SELECT * FROM machines WHERE id='$machine_id'";
    $r = mysqli_query($con, $q);
    $n = mysqli_num_rows($r);
    if($n != 1){
        $out .= "Cannot find machine: $machine_id<br>";
        return $out;
    }
    $machine = mysqli_fetch_array($r);
    $machine_ipaddr   = $machine["ipaddr"];
    $machine_hostname = $machine["hostname"];
    $machine_role     = $machine["role"];
    $cluster_id       = $machine["cluster"];

    $q = "SELECT * FROM clusters WHERE id='$cluster_id'";
    $r = mysqli_query($con, $q);
    $n = mysqli_num_rows($r);
    if($n != 1){
        $out .= "Cannot find cluster: $cluster_id<br>";
        return $out;
    }
    $cluster = mysqli_fetch_array($r);
    $cluster_name = $cluster["name"];
    $cluster_swift_part_power     = $cluster["swift_part_power"];
    $cluster_swift_replicas       = $cluster["swift_replicas"];
    $cluster_swift_min_part_hours = $cluster["swift_min_part_hours"];

    #######################################################
    ### Create a folder for filesystem template of host ###
    #######################################################
    $template_path = "/var/lib/oci/clusters/$cluster_name/$machine_hostname";
    if(!is_dir("/var/lib/oci/clusters")){
        mkdir("/var/lib/oci/clusters", 0755);
    }
    if(!is_dir("/var/lib/oci/clusters/$cluster_name")){
        mkdir("/var/lib/oci/clusters/$cluster_name", 0755);
    }
    if(!is_dir("/var/lib/oci/clusters/$cluster_name/$machine_hostname")){
        mkdir("/var/lib/oci/clusters/$cluster_name/$machine_hostname", 0755);
    }

    #########################
    ### Manage /etc/hosts ###
    #########################
    // Calculate and scp the /etc/hosts file
    $host_file = slave_calculate_hosts_file($con, $conf, $machine_id);
    file_put_contents("$template_path/oci-hosts-file", $host_file);

    #################################################
    ### Create the swift ring if it doesn't exist ###
    #################################################
    # First, we check if there's some swiftstore machines in the cluster, in which case
    # we do need a swift ring.
    $q = "SELECT COUNT(id) AS total FROM machines WHERE cluster='$cluster_id' AND role='swiftstore'";
    $r = mysqli_query($con, $q);
    $a = mysqli_fetch_array($r);

    $swift_ring_path = "/var/lib/oci/clusters/$cluster_name/swift-ring";
//    if($a["total"] >= 1 && !is_dir($swift_ring_path)){
        if(!is_dir($swift_ring_path)){
            mkdir($swift_ring_path, 0755);
        }

        # Account
        $cmd = "swift-ring-builder $swift_ring_path/account.builder create $cluster_swift_part_power $cluster_swift_replicas $cluster_swift_min_part_hours";
        $output = array();
        $return_var = 0;
        exec($cmd, $output, $return_var);

        # Container
        $cmd = "swift-ring-builder $swift_ring_path/container.builder create $cluster_swift_part_power $cluster_swift_replicas $cluster_swift_min_part_hours";
        $output = array();
        $return_var = 0;
        exec($cmd, $output, $return_var);

        # Object
        $cmd = "swift-ring-builder $swift_ring_path/object.builder create $cluster_swift_part_power $cluster_swift_replicas $cluster_swift_min_part_hours";
        $output = array();
        $return_var = 0;
        exec($cmd, $output, $return_var);


        $q = "SELECT INET_NTOA(ips.ip) AS ipaddr, blockdevices.name AS hddname, machines.location_id AS locationid FROM ips,machines,blockdevices WHERE machines.cluster='$cluster_id' AND machines.role='swiftstore' AND machines.id=blockdevices.machine_id AND ips.machine=machines.id AND name NOT LIKE '%da' ORDER BY ips.ip, blockdevices.name";
        $r = mysqli_query($con, $q);
        $n = mysqli_num_rows($r);
        $last_ip = "";
        for($i=0;$i<$n;$i++){
            $blockdev = mysqli_fetch_array($r);
            $blockdev_locationid = $blockdev["locationid"];
            $blockdev_ipaddr     = $blockdev["ipaddr"];
            $blockdev_devicename = $blockdev["hddname"];
            # Account
            $cmd = "swift-ring-builder $swift_ring_path/account.builder add --region 1 --zone $blockdev_locationid --ip $blockdev_ipaddr --port 6002 --device $blockdev_devicename --weight 100";
            $output = array();
            $return_var = 0;
            exec($cmd, $output, $return_var);

            # Container
            $cmd = "swift-ring-builder $swift_ring_path/container.builder add --region 1 --zone $blockdev_locationid --ip $blockdev_ipaddr --port 6001 --device $blockdev_devicename --weight 100";
            $output = array();
            $return_var = 0;
            exec($cmd, $output, $return_var);

            # Object
            if($blockdev_ipaddr != $last_ip){
                $blockdev_object_port = 6200;
            }else{
                $blockdev_object_port += 1;
            }
            $last_ip = $blockdev_ipaddr;
            $cmd = "swift-ring-builder $swift_ring_path/object.builder add --region 1 --zone $blockdev_locationid --ip $blockdev_ipaddr --port $blockdev_object_port --device $blockdev_devicename --weight 100";
            $output = array();
            $return_var = 0;
            exec($cmd, $output, $return_var);
        }

        # Account
        $cmd = "swift-ring-builder $swift_ring_path/account.builder rebalance";
        $output = array();
        $return_var = 0;
        exec($cmd, $output, $return_var);

        # Container
        $cmd = "swift-ring-builder $swift_ring_path/container.builder rebalance";
        $output = array();
        $return_var = 0;
        exec($cmd, $output, $return_var);

        # Object
        $cmd = "swift-ring-builder $swift_ring_path/object.builder rebalance";
        $output = array();
        $return_var = 0;
        exec($cmd, $output, $return_var);
//    }

    if($machine_role == "swiftstore" || $machine_role == "swiftproxy"){
        mkdir("$template_path/oci-in-target");
        mkdir("$template_path/oci-in-target/etc");
        mkdir("$template_path/oci-in-target/etc/swift");
        copy("$swift_ring_path/account.ring.gz", "$template_path/oci-in-target/etc/swift/account.ring.gz");
        copy("$swift_ring_path/container.ring.gz", "$template_path/oci-in-target/etc/swift/container.ring.gz");
        copy("$swift_ring_path/object.ring.gz", "$template_path/oci-in-target/etc/swift/object.ring.gz");
    }

    ###########################################################################
    ### Create a tarball from the $template_path folder, scp it, extract it ###
    ###########################################################################
    $cmd = "tar -C /var/lib/oci/clusters/$cluster_name -cvzf $machine_hostname.tar.gz $machine_hostname";
    $output = array();
    $return_var = 0;
    exec($cmd, $output, $return_var);
    scp_a_file($conf, $con, $machine_ipaddr, "/var/lib/oci/clusters/$cluster_name/$machine_hostname.tar.gz", "/oci-to-extract-tarball.tar.gz", 0644);
    $ret = send_ssh_cmd($conf, $con, $machine_ipaddr, "tar -C / -xvzf /oci-to-extract-tarball.tar.gz");

    #####################################
    ### Perform the actual OS install ###
    #####################################
//    $ret = send_ssh_cmd($conf, $con, $machine_ipaddr, $install_cmd);
}

build_my_ring($con, $conf, 17, "");

?>
